<template>
  <v-btn prepend-icon="mdi-plus" :disabled="showDialog" @click="openDialog()">
    Rolle hinzufügen
  </v-btn>

  <v-dialog v-model="showDialog" max-width="600">
    <v-card prepend-icon="mdi-plus" title="Rolle hinzufügen">
      <v-card-text>
        <v-row dense>
          <v-col cols="12" sm="12">
            <v-text-field
              label="Name:*"
              v-model="form.name"
              :rules="formErrors.name"
              :error-messages="nameExistsError ? 'Dieser Name existiert bereits!' : ''"
              @update:modelValue="nameExistsError = false"
              required
            ></v-text-field>
          </v-col>

          <v-col cols="12">
            <v-select
              v-model="form.rightIds"
              :items="roleRights"
              item-title="name"
              item-value="id"
              label="Rollen Berechtigungen:"
              clearable
              chips
              multiple
            >
            </v-select>
          </v-col>
        </v-row>

        <small class="text-caption text-medium-emphasis">
          *kennzeichnet ein Pflichtfeld
        </small>
      </v-card-text>

      <v-divider></v-divider>

      <v-card-actions>
        <v-spacer></v-spacer>

        <div class="d-flex flex-row justify-space-between w-100">
          <v-btn text="Abbrechen" color="error" @click="showDialog = false"></v-btn>

          <v-btn
            text="Rolle erstellen"
            color="success"
            :disabled="isFormInvalid()"
            @click="submitForm()"
          ></v-btn>
        </div>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<script setup lang="ts">
import { AxiosError } from "axios";
import { onMounted, ref } from "vue";
import { RoleBody, RoleRightResponse, api } from "../api";

const emits = defineEmits<{ (event: "submitted"): void }>();

const showDialog = ref<boolean>(false);

const nameExistsError = ref<boolean>(false);

const roleRights = ref<RoleRightResponse[]>([]);

const form = ref<RoleBody>({
  name: "",
  rightIds: [],
});

const formErrors = {
  name: [
    (value: string) => {
      if (value?.length === 0) {
        return "Bitte gebe einen Namen an!";
      }
      return true;
    },
  ],
};

function openDialog(): void {
  form.value = {
    name: "",
  };

  showDialog.value = true;
}

function isFormInvalid(): boolean {
  const { name } = form.value;

  return name.length === 0;
}

function submitForm(): void {
  if (isFormInvalid()) {
    return;
  }
  console.log(form.value);
  api.roles
    .createRole(form.value)
    .then(() => {
      emits("submitted");
      showDialog.value = false;
    })
    .catch((error: AxiosError) => {
      if (error?.response?.status === 409) {
        nameExistsError.value = true;
        return;
      }
      console.error(error);
    });
}

async function loadRoleRights(): Promise<void> {
  const { data, status, statusText } = await api.roleRights.getAllRoleRights();

  if (status !== 200) {
    console.error(statusText);
    return;
  }
  roleRights.value = data;
}

onMounted(loadRoleRights);
</script>
